<template>
  <div>test4 请看打印</div>
</template>

<script>
export default {
  data() {
    return {
      arr1: [
        { name: "Facebook", age: 24 },
        { name: "Github", age: 18 },
        { name: "OpenAI", age: 18 }
      ],
      arr2: [
        { name: "Google", age: 24 },
        { name: "Copilot", age: 20 },
        { name: "John", age: 24 }
      ]
    };
  },
  mounted() {
    console.log(this.groupByAge(this.arr1, this.arr2));
  },
  methods: {
    groupByAge(arr1, arr2) {
      let obj = {};
      let obj1 = {};
      arr1
        .concat(arr2) // 将arr1 和 arr2 合并成 新的数组   concat 拼接成新的数据
        .reduce((item, next) => {
          // 利用reduce 方法给数组去重
          obj[next.name] ? "" : (obj[next.name] = true && item.push(next));
          return item;
        }, [])
        .sort((a, b) => a.age - b.age) // 按照age从小到大给数组排序 因每个item是obj，所以排序对象的age属性进行排序
        .forEach((e) => {
          // 最后将 年龄相同的 数据放在同一个对象的属性下面
          if (!obj1[e.age]) {
            obj1[e.age] = [e];
          } else {
            obj1[e.age].push(e);
          }
        });
      return obj1;
    }
  }
};
</script>

<style lang="scss" scoped></style>
